TorqueScript Reference

- Main Page
- Related Pages
- Modules
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
NetConnection Class Reference

Inherits SimGroup.

Inherited by GameConnection.

## Public Member Functions
void | checkMaxRate ()
void | connect (remoteAddress)
String | connectLocal ()
String | getAddress ()
Integer | getGhostID (S32 realID)
S32 | getGhostsActive ()
Integer | getPacketLoss ()
Integer | getPing ()
Integer | resolveGhostID (S32 ghostID)
Integer | resolveObjectFromGhostIndex (S32 ghostIdx)
void | setSimulatedNetParams (packetLoss, delay)

## Member Function Documentation

void checkMaxRate | ( |  | ) |

Use the checkMaxRate method to retrieve the current maximum packet rate for this connection. The period may not neccesarily be one second. To adjust packet rates, see the preference variables above

Returns
  Returns an integer value representing the maximum number of packets that can be transmitted by this connection per transmission period.

void connect | ( | remoteAddress |  | ) |

Use the connect method to request a connection to a remote server at the address remoteAddress.

Parameters

  remoteAddress | A string containing an address of the form: A.B.C.D:Port, where A .. B are standard IP numbers between 0 and 255 and Port can be between 1000 and 65536.

Returns
  No return value.

See also
  connectLocal, getAddress

String connectLocal | ( |  | ) |

Use the connectLocal method to connect the current client-side connection to a local NetConnection, that is to create an internal connection from this client to the internal server. This is accomplished through the use of a back door mechanism and has an extremely high bandwidth.

Returns
  No return value.

See also
  connect, getAddress

String getAddress | ( |  | ) |

Use the getAddress method to get the address and port that this NetConnection is currently attached to.

Returns
  Returns the address and port that this NetConnection is currently attached to, where the addres will be of the form: A.B.C.D:Port. A .. B are standard IP numbers between 0 and 255 and Port can be between 1000 and 65536. If the connection is local, the string 'local' will be returned. If a this NetConnection is not currently connected the method will return a NULL string.

See also
  connect, connectLocal

Integer getGhostID | ( | S32 | realID | ) |

Convert a real id to the ghost id for this connection.

Returns
  The ID as an integer

S32 getGhostsActive | ( |  | ) |

Use the getGhostsActive method to determine how many ghosts are active on a particular connection.

Returns
  Returns an integer value between 0 and inf, specifying how many objects are being ghosted to a client on the other side of a specific connection

Integer getPacketLoss | ( |  | ) |

Use the getPacketLoss method to determine the current packetLoss count for this connection.

Returns
  Returns an integer value between 0 and inf, indicating the number of packets that have been lost to date on this net connection.

See also
  getPing

Integer getPing | ( |  | ) |

Use the getPing method to determine the round-trip travel time from this connection to the agent on the other end and back again.

Returns
  Returns an integer value representing the total time in milliseconds it takes for a ping request to travel to the agent on the other end of a connection and back to this agent.

See also
  getPacketLoss

Integer resolveGhostID | ( | S32 | ghostID | ) |

Convert a ghost id from this connection to a real id.

Returns
  The ID as an integer

Integer resolveObjectFromGhostIndex | ( | S32 | ghostIdx | ) |

Convert a ghost index from this connection to a real id.

Returns
  The ID as an integer

void setSimulatedNetParams | ( | packetLoss | ,
|  | delay |
| ) |  |

Use the setSimulatedNetParams method to force a connection to experience a certain degree of packet-loss and/or latency. This is a debug feature to allow us to see how a distributed game will behave in the face of poor connection quality.

Parameters

  packetLoss | A floating-point value between 0.0 (0%) and 1.0 (100%) dictating the percentage of packets to be artificially lost.
  delay | An integer value specifying the number of milliseconds to insert into transmission latencies.

Returns
  No return value.

See also
  getPacketLoss, getPing